var TIME_BETWEEN_RETRIES = 250;
var TIMES_TO_RETRY = 80;
var ADOBE_ORG_ID = '05FF6243578784B37F000101@AdobeOrg';
var ADOBE_SERVERS = {
  trackingServer: 'schibstedspain.d3.sc.omtrdc.net',
  trackingServerSecure: 'schibstedspain.d3.sc.omtrdc.net'
};

var getMarketingCloudVisitorID = function getMarketingCloudVisitorID() {
  var mcvid;

  try {
    var demdex = window.Visitor.getInstance(ADOBE_ORG_ID, ADOBE_SERVERS);
    mcvid = demdex.getMarketingCloudVisitorID();
  } catch (_unused) {
    mcvid = '';
  }

  return mcvid;
};

export var getAdobeMarketingCloudVisitorIdFromWindow = function getAdobeMarketingCloudVisitorIdFromWindow() {
  if (window.__mpi.visitorId) return Promise.resolve(window.__mpi.visitorId);
  return new Promise(function (resolve) {
    function retry(retries) {
      if (retries === 0) return resolve('');
      window.__mpi.visitorId = getMarketingCloudVisitorID();
      return window.__mpi.visitorId ? resolve(window.__mpi.visitorId) : window.setTimeout(function () {
        return retry(--retries);
      }, TIME_BETWEEN_RETRIES);
    }

    retry(TIMES_TO_RETRY);
  });
};