import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import Cookies from 'js-cookie';
import { v4 as uuid } from 'uuid';
import { getAdobeMarketingCloudVisitorIdFromWindow } from './adobeRepository';
var LOCALHOST = 'localhost';
var IJ_VISITOR_COOKIE_NAME = 'IJ_MCMID';

function getDomain(_ref) {
  var _ref$host = _ref.host,
      host = _ref$host === void 0 ? window.location.host : _ref$host;
  if (host.includes(LOCALHOST)) return LOCALHOST;
  return host.split('.').slice(-2).join('.');
}

export function getVisitorIdCallback(_ref2) {
  var host = _ref2.host,
      _ref2$getCookie = _ref2.getCookie,
      getCookie = _ref2$getCookie === void 0 ? Cookies.get : _ref2$getCookie,
      _ref2$setCookie = _ref2.setCookie,
      setCookie = _ref2$setCookie === void 0 ? Cookies.set : _ref2$setCookie,
      _ref2$getMarketingClo = _ref2.getMarketingCloudVisitorId,
      getMarketingCloudVisitorId = _ref2$getMarketingClo === void 0 ? getAdobeMarketingCloudVisitorIdFromWindow : _ref2$getMarketingClo;
  return function () {
    if (window.__mpi.visitorId) return Promise.resolve(window.__mpi.visitorId); // useractioncomplete when the user accepts or declines the consents
    // tcloaded when the user did already accept or decline the consents

    return new Promise(function (resolve) {
      window.__tcfapi('addEventListener', 2, /*#__PURE__*/function () {
        var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(_ref3) {
          var eventStatus, isEvent, visitorId, domain;
          return _regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  eventStatus = _ref3.eventStatus;
                  isEvent = ['useractioncomplete', 'tcloaded'].includes(eventStatus);

                  if (isEvent) {
                    _context.next = 4;
                    break;
                  }

                  return _context.abrupt("return", Promise.resolve());

                case 4:
                  visitorId = getCookie(IJ_VISITOR_COOKIE_NAME);

                  if (visitorId) {
                    _context.next = 15;
                    break;
                  }

                  _context.prev = 6;
                  _context.next = 9;
                  return getMarketingCloudVisitorId();

                case 9:
                  visitorId = _context.sent;
                  _context.next = 15;
                  break;

                case 12:
                  _context.prev = 12;
                  _context.t0 = _context["catch"](6);
                  console.error(_context.t0);

                case 15:
                  if (!visitorId) {
                    visitorId = uuid();
                  } // Domain must be saved without `www` in order to be saved as .infojobs.net


                  domain = getDomain({
                    host: host
                  });
                  setCookie(IJ_VISITOR_COOKIE_NAME, visitorId, {
                    expires: 365,
                    domain: domain
                  });
                  window.__mpi.visitorId = visitorId;
                  return _context.abrupt("return", resolve(visitorId));

                case 20:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, null, [[6, 12]]);
        }));

        return function (_x) {
          return _ref4.apply(this, arguments);
        };
      }());
    });
  };
}

function getSite(_ref5) {
  var _ref5$host = _ref5.host,
      host = _ref5$host === void 0 ? window.location.host : _ref5$host;
  return host.indexOf('infojobs.it') > -1 ? 'infojobs.it' : 'infojobs.net';
}

export default (function (dependencies) {
  // will be accessed by the segment-wrapper
  window.__mpi = {
    segmentWrapper: {
      facebookPixelId: 283351338713870,
      googleAdsPixelId: 1024323628,
      defaultProperties: {
        site: getSite(dependencies),
        vertical: 'jobs'
      },
      defaultContext: {
        site: getSite(dependencies)
      },
      getCustomAdobeVisitorId: getVisitorIdCallback(dependencies),
      tcfTrackDefaultProperties: {
        vertical: 'jobs'
      }
    }
  };
});